BidMonitorUI = {}

local Bidders = {}

--Top level frame
fMonitorUI = CreateFrame("Frame","frmMonitorUI",UIParent)

fMonitorUI:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile=1, tileSize=32, edgeSize=32, 
			insets={left=11, right=12, top=12, bottom=11}
	})



fMonitorUI:SetWidth(200)
fMonitorUI:SetHeight(400)
fMonitorUI:SetPoint("CENTER",UIParent)
fMonitorUI:EnableMouse(true)
fMonitorUI:SetMovable(true)
fMonitorUI:RegisterForDrag("LeftButton")
fMonitorUI:SetScript("OnDragStart", function(self) self:StartMoving() end)
fMonitorUI:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
fMonitorUI:SetFrameStrata("MEDIUM")

local l1 = fMonitorUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
l1:SetPoint("TOP", 0, -15)
l1:SetText("Bid Monitor")

local btnClose = CreateFrame("Button","btnBidClose",fMonitorUI, "UIPanelCloseButton")
btnClose:SetSize(32 ,32) -- width, height
btnClose:SetPoint("TOPRIGHT", -5, -5)
btnClose:SetScript("OnClick", function() BidMonitorUI.HideUI() end)

fMonitorUI:Hide()	












------------------------------------ Function here
function BidMonitorUI.PlayerOpenedBidding(playerName)
	--check to see if they exist already
	lbl = Bidders[playerName]
	if(lbl == nil) then
		-- need to create the lable for the playerName
		bidderCount = tablelength(Bidders)

		local bl = fMonitorUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		bl:SetPoint("TOPLEFT", 20 , -15 * (bidderCount + 2))
		bl:SetText( playerName .. " -|cFF00FF00 ACTIVE")

		Bidders[playerName] = bl
	else
		--We have the label, just make it ACTIVE
		lbl:SetText( playerName .. " -|cFF00FF00 ACTIVE")
	end
end

function BidMonitorUI.PlayerClosedBidding(playerName)
	--check to see if they exist already
	lbl = Bidders[playerName]
	if(lbl ~= nil) then
		lbl:SetText( playerName .. " -|cFFFF0000 CLOSED")
	end
end

function BidMonitorUI.ShowUI()
	fMonitorUI:Show()
end
function BidMonitorUI.HideUI()
	fMonitorUI:Hide()
end


---------- Utility functions

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end
