RPBSBidUI = {} --Addon pointer

local Bid_Points = 0
local Current_Bid = 0
local High_Bid = 0
local High_Bidder_Name = "No Winner"
local itemLink = nil

---------------------------------
--UI Elements
---------------------------------
fBidUI = CreateFrame("Frame","frmBidUI",UIParent)

function RPBSBidUI.CreateBidUI()
	fBidUI:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})



	fBidUI:SetWidth(200)
	fBidUI:SetHeight(185)
	fBidUI:SetPoint("CENTER",UIParent)
	fBidUI:EnableMouse(true)
	fBidUI:SetMovable(true)
	fBidUI:RegisterForDrag("LeftButton")
	fBidUI:SetScript("OnDragStart", function(self) self:StartMoving() end)
	fBidUI:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	fBidUI:SetFrameStrata("MEDIUM")

	fBidUI:SetPoint("CENTER",200,0)

	local l1 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l1:SetPoint("TOP", 0, -15)
	l1:SetText("Bidding")
	--create a button to call our functions

	local btnPlaceBid = CreateFrame("Button","btnPlaceBid",fBidUI, "UIPanelButtonTemplate")
	btnPlaceBid:SetSize(80 ,25) -- width, height
	btnPlaceBid:SetText("Place Bid")
	btnPlaceBid:SetPoint("TOP", 10, -40)
	btnPlaceBid:SetScript("OnClick", function() RPBSBidUI.PlaceBid() end)


	local btnBidClose = CreateFrame("Button","btnBidClose",fBidUI, "UIPanelCloseButton")
	btnBidClose:SetSize(32 ,32) -- width, height
--	btnBidClose:SetText("Close")
	btnBidClose:SetPoint("TOPRIGHT", -5, -5)
	btnBidClose:SetScript("OnClick", function() RPBSBidUI.HideBidUI() end)



--	lItem = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
--	lItem:SetPoint("TOP", 0, -30)
--	lItem:SetText("Item for bid")


	local l2 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l2:SetPoint("TOPLEFT", 20, -90)
	l2:SetText("Your Pts:")

	lblPoints = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblPoints:SetPoint("TOPLEFT", 85, -90)

	local l4 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l4:SetPoint("TOPLEFT", 20, -110)
	l4:SetText("Your Bid:")

	local l4 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l4:SetPoint("TOPLEFT", 20, -130)
	l4:SetText("High Bid:")

	lblCurrentBid = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblCurrentBid:SetPoint("TOPLEFT", 85, -110)

	lblHighBid = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblHighBid:SetPoint("TOPLEFT", 85, -130)

	lblFinal = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblFinal:SetPoint("TOPLEFT", 20, -150)

	--Create the image holder
	RPBSBidUI.CreateItemPic()

	fBidUI:Hide()	
	

end

function RPBSBidUI.StartBidding(item)
	RPBSBidUI.ClearFinalBid()
	Current_Bid = 0
	High_Bid = 0
	High_Bidder_Name = "No Winner"
	lblPoints:SetText(Current_Points)
	lblHighBid:SetText(High_Bid)
	lblCurrentBid:SetText(Current_Bid)
	itemLink = item
	RPBSBidUI.LoadItemImage()
	RPBSBidUI.ShowBidUI()
end

function RPBSBidUI.EndBidding()
	fBidUI:Hide()
end

function RPBSBidUI.ShowBidUI()
	--RPBS.HideUI()
	fBidUI:Show()
	SendAddonMessage(CHAT_MSG_PREFIX, "BidWindowOpen-0-" .. UnitName("player"),  RPBS.GetInstanceChannel());
end

function RPBSBidUI.HideBidUI()
	fBidUI:Hide()
	if(bML) then
		SendChatMessage("Bidding has ended. WINNER: " .. High_Bidder_Name,"RAID");
		SendAddonMessage(CHAT_MSG_PREFIX, "EndBidding-" .. High_Bid .. "-" .. High_Bidder_Name,  RPBS.GetInstanceChannel());
	else
		SendAddonMessage(CHAT_MSG_PREFIX, "BidWindowClose-0-" .. UnitName("player"),  RPBS.GetInstanceChannel());
	end
end


function RPBSBidUI.PlaceBid()
	if(Current_Bid == Current_Points) then
		message("You have no more points to bid with!")
		return
	end
	if(High_Bid > Current_Points) then
		message("Bidding is beyond your availble points!")
		return
	end
	if(Current_Bid <= High_Bid) then
		Current_Bid = High_Bid + 1
	end

	SendAddonMessage(CHAT_MSG_PREFIX, "PlaceBid-" .. Current_Bid .. "-" .. UnitName("player"), "RAID");
	lblCurrentBid:SetText(Current_Bid)
end

function RPBSBidUI.UpdateHighBid(points)
	local iPoints = tonumber(points)
	if(iPoints > High_Bid) then
		lblHighBid:SetText(points)
		High_Bid = iPoints
	end
end

function RPBSBidUI.UpdateHighBidMaster(points, name)
	local iPoints = tonumber(points)
	if(iPoints > High_Bid) then
		lblHighBid:SetText(points .. " - " .. name)
		High_Bid = iPoints
		High_Bidder_Name = name
	end
end

function RPBSBidUI.ShowFinalBid()
	lblFinal:SetText("Final")
end

function RPBSBidUI.ClearFinalBid()
	lblFinal:SetText("")
end



--Item functions for linking
--local testItemString = "item:16846:0:0:0:0:0:0:0"

function RPBSBidUI.CreateItemPic()
	itemFrame = CreateFrame("Button", "frmItem", fBidUI)
	itemFrame.UpdateTooltip = nil
	itemFrame:SetPoint('TOPLEFT', 0, -15)
	itemFrame:SetSize(75,75)
	itemFrame:SetScript("OnEnter", function() RPBSBidUI.OnEnter() end)
	itemFrame:SetScript("OnLeave", RPBSBidUI.OnLeave)

	img = itemFrame:CreateTexture(nil, 'OVERLAY')
	img:SetPoint('CENTER', itemFrame)
	img:SetBlendMode('ADD')
	img:SetSize(40, 40)
end

function RPBSBidUI.LoadItemImage()
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
	img:SetTexture(itemTexture)
end

function RPBSBidUI.OnEnter()
	RPBSBidUI:ShowTooltip()
end

function RPBSBidUI.OnLeave()
	GameTooltip:Hide()
end

function RPBSBidUI.ShowTooltip()
	RPBSBidUI:AnchorTooltip()
	GameTooltip:SetHyperlink(itemLink)
	GameTooltip:Show()
end

function RPBSBidUI.AnchorTooltip()
	if fBidUI:GetRight() >= (GetScreenWidth() / 2) then
		GameTooltip:SetOwner(fBidUI, 'ANCHOR_LEFT')
	else
		GameTooltip:SetOwner(fBidUI, 'ANCHOR_RIGHT')
	end
end

